/*
This program was written by Heather Anne Kiefer, known online as either HAK or ArrPirate.
This is her first ever c++ program so the code is likely very inefficient but she's trying
to make it better. Please be kind to her. Also, it's fine if you edit this code, but please
give Heather credit where credit is due. Thank you. Have a great day!
*/

#include <nds.h>
#include <stdio.h>
#include <math.h>
#include <iostream>
#include <fat.h>
#include <time.h>
#include <cstring>
#include <list>
#include "main.h"

using namespace std;

const char* months[12] = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
enum { TOP=1, BOTTOM=0 };
enum whichScreen { TOPSCREEN=1, BOTTOMSCREEN=2, BOTHSCREENS=3 };
const char* MealNames[5] = {"All", "Pre-Breakfast", "Pre-Lunch", "Pre-Dinner", "Pre-Bed"};

list<BLOODINFO> bloodDataList;

int main(void)  

{
    int optionselected;

    fatInitDefault();
    handleDisplay();
    setupKeyboard();
	
    char menuItems[4][50];
	strcpy(menuItems[0], "Unit Calculator");
	strcpy(menuItems[1], "Blood Sugar Log");
	strcpy(menuItems[2], "Journal");
	strcpy(menuItems[3], "Shut Down");
    
	time_t unixTime = time(NULL);
	struct tm* timeStruct = gmtime((const time_t *)&unixTime);
	int day;
	int dayIn;
	day = timeStruct->tm_yday;
	FILE* input = fopen ("/Health/dayinfo.ini", "r");
	fscanf(input, "%i", &dayIn);
    fclose (input);
    if(dayIn != day)
    {
        FILE* config = fopen ("/Health/config.ini", "r");
        int units;
        fscanf(config, "%i", &units);
        fclose (config);
        FILE* unitOutput = fopen ("/Health/units.ini", "w+");
        fprintf(unitOutput, "%i", units);
        fclose (unitOutput);
        FILE* output = fopen ("/Health/dayinfo.ini", "w+");
        fprintf(output, "%i", day);
        fclose (output);
    }

    while(1)
    {
        optionselected=menu(4, menuItems);
        menuSelection(optionselected);
    }

}

// This function sets up the displays on both the top and bottom screens.
void handleDisplay()
{
    videoSetMode(MODE_0_2D);
    videoSetModeSub(MODE_0_2D);
    vramSetBankA(VRAM_A_MAIN_BG);
    vramSetBankC(VRAM_C_SUB_BG);   
    topScreen = *consoleInit(0, 3,BgType_Text4bpp, BgSize_T_256x256, 31, 0, true);
    bottomScreen = *consoleInit(0, 3,BgType_Text4bpp, BgSize_T_256x256, 31, 0, false);

    bottomLeft = *consoleDemoInit();  
    bottomRight = *consoleDemoInit();;
    consoleSetWindow(&bottomLeft, 0,0,2,24);
    consoleSetWindow(&bottomRight, 2,0,30,24);

    consoleDemoInit();
}

// This function sets up the keyboard for use.
void setupKeyboard()
{
    Keyboard *kbd = keyboardGetDefault();
    kbd->OnKeyPressed = OnKeyPressed;
    keyboardInit(kbd);
}

// This function accepts the input from the keys.
void OnKeyPressed(int key)
{
    if(key > 0)
    iprintf("%c", key);
}

void clearScreen(bool Top=false) {                     
    consoleSelect( (Top)? &topScreen : &bottomScreen );
    consoleClear();                                    
}                                                      


void clearWhichScreen(whichScreen nScreenToClear) 
{                            

    switch (nScreenToClear) {                                             
        case TOPSCREEN    : clearScreen(TOP);                      break; 
        case BOTTOMSCREEN :                   clearScreen(BOTTOM); break; 
        case BOTHSCREENS  : clearScreen(TOP); clearScreen(BOTTOM); break; 
    }                                                                     
                                                                          
    swiWaitForVBlank();
	
}                                                                         

// This function handles the display of the menu.
int menu(int nMenuItems, char sMenuItem[][50])
{
    int option;
    int optionselected;

    option = 1;
    optionselected = 0;
    
    consoleSelect(&bottomRight);

	for (int nLoop=0; nLoop < nMenuItems; nLoop++)
	{
		cout << sMenuItem[nLoop] << "\n\n";
	}


    while(1)
    {
        scanKeys();
		consoleSelect(&bottomLeft);
        for(int loopx = 1; loopx < option; loopx++)
        {
            cout<<"\n\n";
        }
        cout<<">";

        if (keysDown() & KEY_UP)
        {
            if(nMenuItems <= option + 2)
            {
                option--;
            }
        } else if (keysDown() & KEY_DOWN)
        {
            if(nMenuItems >= option + 1)
            {
                option++;
            }
        }
        if (keysDown() & KEY_A)
        {
            clearWhichScreen(BOTHSCREENS);
            optionselected = option;
            break;
        }
        // touch screen goes here
		if(keysDown() & KEY_TOUCH)
        {
            int spacer;
            spacer = 0;
    		for (int nLoop = 0; nLoop < nMenuItems; nLoop++)
    		{
                touchRead(&touch);
                int x;
                int y;
                x = touch.px;
                y = touch.py;
                int x1;
                int x2;
                int y1;
                int y2;
                
                y1 = (nLoop * 8) + spacer;
                y2 = (nLoop * 8) + (8 + spacer);
                x1 = 16;
                x2 = 8 * strlen(sMenuItem[nLoop]) + 16;
                
                consoleSelect(&bottomScreen);
    			if(touch.py >= y1 && touch.py <= y2 && touch.px >= x1 && touch.px <= x2)
                {
                    clearWhichScreen(BOTHSCREENS);
                    optionselected = nLoop + 1;
                    break;
                }
                spacer = spacer + 8;
    		}
    		
    		if (optionselected > 0)
    		{
    		    
    		    break;
    		}

		}
        
        consoleSelect(&bottomLeft);
        swiWaitForVBlank();
        consoleClear();
        
    }
    consoleSelect(&bottomRight);
    swiWaitForVBlank();
    consoleClear();
    consoleSelect(&bottomRight);
    swiWaitForVBlank();
    consoleClear();
    consoleSelect(&bottomScreen);
    return optionselected;
}

// This function handles what selecting a menu item does.
void menuSelection(int optionselected)
{
    switch(optionselected)
    {
        case 1:
            foodInfo();
            break;
        case 2:
            bloodInfo();
            break;
        case 3:
            journal();
            break;
        case 4:
            powerOn(PM_SYSTEM_PWR); 
            break;
    }
    

    
    optionselected = 0;
}

// This function handles the unit calculation.
int foodInfo()
{
    while(1)

    {

        float calories;
        float fat;
        float fiber;
        float carbs;
        float caltotal;
        float fattotal;
        float fibertotal;
        float totalone;
        float totaltwo;
        int mealtime;
        int optionselected;
        char sName[500]; 
        calories = 0;
        fat = 0;
        fiber = 0;
        char menuItems[2][50];
        strcpy(menuItems[0], "Quick Calculator");
	    strcpy(menuItems[1], "Journal");
    	optionselected=menu(2, menuItems);
    	int skip;
    	if(optionselected == 1)
    	{
    	   skip=1;
    	}
    	else
    	{
    	    skip=0;
    	}
    	if(skip==0)
    	{
            keyboardShow();
            consoleSelect(&topScreen);
            cout<<"What is the name of the food?\n\n";
        
            consoleSelect(&bottomScreen);
            fgets(sName, 50, stdin);
            clearWhichScreen(BOTHSCREENS);
            keyboardHide();
        
            char menuItems[4][50];
            strcpy(menuItems[0], "Breakfast");
    	    strcpy(menuItems[1], "Lunch");
        	strcpy(menuItems[2], "Dinner");
        	strcpy(menuItems[3], "Snack");
        	mealtime=menu(4, menuItems);
        }
        
        keyboardShow();
        clearWhichScreen(BOTHSCREENS);
        consoleSelect(&topScreen);
        cout<<"How many calories does it have?\n\n";
        while(1)
        {
            consoleSelect(&bottomScreen);
            if (1 == scanf("%f", &calories))
            {
                clearWhichScreen(BOTHSCREENS);
                break;
            }
            else
            {
                swiWaitForVBlank();
                clearWhichScreen(BOTHSCREENS);			
                cout<<"Error: Please enter a number.\n\n";
                consoleSelect(&topScreen);
                cout<<"How many calories does it have?\n\n";
                scanKeys();
                while(!keysDown())scanKeys();
                char c; // used to clear the input
                while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.

            }
        }

        consoleSelect(&topScreen); //This block is for fat input.
        cout<<"How many grams of fat does it\nhave?\n\n";
        while(1)
        {
            consoleSelect(&bottomScreen);
            if (1 == scanf("%f", &fat))
            {
                char c; // used to clear the input
                while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.
                clearWhichScreen(BOTHSCREENS);
                break;
            }
            else
            {
                swiWaitForVBlank();
                clearWhichScreen(BOTHSCREENS);
                cout<<"Error: Please enter a number.\n\n";
                consoleSelect(&topScreen);
                cout<<"How many grams of fat does it\nhave?\n\n";
                while(!keysDown())scanKeys();
                char c; // used to clear the input
                while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.
            }
        }

        consoleSelect(&topScreen); //This block is for fiber input.
        cout<<"How many grams of fiber does it\nhave?\n\n";
        while(1)
        {
            consoleSelect(&bottomScreen);
            if (1 == scanf("%f", &fiber))
            {
                char c; // used to clear the input
                while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.
                clearWhichScreen(BOTHSCREENS);
                break;
            }
            else
            {
                char c;
                swiWaitForVBlank();
                clearWhichScreen(BOTHSCREENS);
                cout<<"Error: Please enter a number.\n\n";
                consoleSelect(&topScreen);
                cout<<"How many grams of fiber does it\nhave?\n\n";
                while(!keysDown())scanKeys();
                while((c = getchar()) != '\n' && c != EOF);
            }
        }
        
        consoleSelect(&topScreen); //This block is for fiber input.
        cout<<"How many grams of carbs does it\nhave?\n\n";
        while(1)
        {
            consoleSelect(&bottomScreen);
            if (1 == scanf("%f", &carbs))
            {
                char c; // used to clear the input
                while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.
                clearWhichScreen(BOTHSCREENS);
                break;
            }
            else
            {
                char c;
                swiWaitForVBlank();
                clearWhichScreen(BOTHSCREENS);
                cout<<"Error: Please enter a number.\n\n";
                consoleSelect(&topScreen);
                cout<<"How many grams of carbs does it\nhave?\n\n";
                while(!keysDown())scanKeys();
                while((c = getchar()) != '\n' && c != EOF);
            }
        }
        
        if(fiber > 5)
        {
            carbs = carbs - fiber;
        }
        
        caltotal = calories / 50;
        fattotal = fat /12;
        
        if (fiber < 4)
        {
            fibertotal = fiber / 5;
        }
        else
        {
            fibertotal = 4 / 5;
        }

        consoleSelect(&topScreen); // This block is for displaying the results.
        totalone = caltotal + fattotal - fibertotal;
        totaltwo = floor(totalone + .5);
        keyboardHide();
        if(skip==0)
        {
            cout<<"Food Name: "<< sName <<"\n";
            switch(mealtime)
            {
                case 1:
                    cout<<"Mealtime: Breakfast\n";
                    break;
                case 2:
                    cout<<"Mealtime: Lunch\n";
                    break;
                case 3:
                    cout<<"Mealtime: Dinner\n";
                    break;
                case 4:
                    cout<<"Mealtime: Snack\n";
                    break;
            }
        }
        cout<<"\nYour food is worth "<< totaltwo <<" units.\n";
        cout<<"\nYour food has "<< carbs <<" grams of carbs.\n";
        FILE* unitInput = fopen ("/Health/units.ini", "r");
        int units;
        fscanf(unitInput, "%i", &units);
        fclose (unitInput);
        int totalthree;
        totalthree = units - totaltwo;
        cout<<"\nYou have "<<totalthree<<" units left.\n";
        scanKeys(); // This and the next line is a 'wait until key is pressed' feature

        
        if(skip==0)
        {
       		time_t unixTime = time(NULL);
    		struct tm* timeStruct = gmtime((const time_t *)&unixTime);
    		int hours;
    		int minutes;
    		hours = timeStruct->tm_hour;
    		minutes = timeStruct->tm_min;
            FILE* output = fopen ("/Health/foodjournal.txt", "a+");
            fprintf(output, "%i %i %i\n", timeStruct->tm_mon, timeStruct->tm_mday, timeStruct->tm_year +1900);
            switch(mealtime)
            {
                case 1:
                    fprintf(output, "Breakfast\n");
                    break;
                case 2:
                    fprintf(output, "Lunch\n");
                    break;
                case 3:
                    fprintf(output, "Dinner\n");
                    break;
                case 4:
                    fprintf(output, "Snack\n");
                    break;
            }
            fprintf(output, "%02i:%02i %s", hours, minutes, sName);
            fprintf(output, "Carbs: %.1f\n", carbs);
            fprintf(output, "Units: %.0f\n", totaltwo);
            fclose (output);
            
            FILE* unitInput = fopen ("/Health/units.ini", "r");
            int units;
            fscanf(unitInput, "%i", &units);
            fclose (unitInput);
            FILE* unitOutput = fopen ("/Health/units.ini", "w+");
            fprintf(unitOutput, "%i", totalthree);
            fclose (unitOutput);
        }
        while(!keysDown())scanKeys();
        swiWaitForVBlank();

        clearWhichScreen(BOTHSCREENS);
        break;

    }
    return 0;
}

int bloodInfo()
{
    while(1)

    {

        int sugar;
        int bloodtime;
        int optionselected;

        sugar = 0;
        
        clearWhichScreen(BOTHSCREENS);
        char menuItems[4][50];
        strcpy(menuItems[0], "Pre-Breakfast");
	    strcpy(menuItems[1], "Pre-Lunch");
    	strcpy(menuItems[2], "Pre-Dinner");
    	strcpy(menuItems[3], "Pre-Bed");
    	optionselected=menu(4, menuItems);
        bloodtime=optionselected;
        scanKeys();
        
        clearWhichScreen(BOTHSCREENS);
        consoleSelect(&topScreen);
        cout<<"What was your blood sugar?\n\n";
        keyboardShow();

        while(1)
        {
            consoleSelect(&bottomScreen);
            if (1 == scanf("%d", &sugar))
            {
                clearWhichScreen(BOTHSCREENS);
                break;
            }
            else
            {
                swiWaitForVBlank();
                clearWhichScreen(BOTHSCREENS);			

                cout<<"Error: Please enter a number.\n\n";
                consoleSelect(&topScreen);
                cout<<"What was your blood sugar?\n\n";
                scanKeys();

                while(!keysDown())scanKeys();
                char c; // used to clear the input
                while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.

            }
        }

        consoleSelect(&topScreen); // This block is for displaying the results.
        keyboardHide();
        cout<<"Blood Sugar: "<< sugar <<"\n";
        switch(bloodtime)
        {
            case 1:
                cout<<"Test: Pre-Breakfast\n";
                break;
            case 2:
                cout<<"Test: Pre-Lunch\n";
                break;
            case 3:
                cout<<"Test: Pre-Dinner\n";
                break;
            case 4:
                cout<<"Test: Pre-Bed\n";
                break;
        }
        if(sugar >=60 && sugar <=79)
        {
            cout<<"Your blood sugar is normal.";
        }else if(sugar >= 80 && sugar <= 99)
        {
            cout<<"Your blood sugar is high-normal.";
        }else if(sugar >=100 && sugar <=109)
        {   
            cout<<"Your blood sugar is safe.";
        }else if(sugar >= 110 && sugar <= 140)
        {
            cout<<"Your blood sugar is ok.";
        }else
        {
            cout<<"Your blood sugar is unsafe.";
        }
        scanKeys(); // This and the next line is a 'wait until key is pressed' feature

        while(!keysDown())scanKeys();
        swiWaitForVBlank();
        clearWhichScreen(BOTHSCREENS);
        
   		time_t unixTime = time(NULL);
		struct tm* timeStruct = gmtime((const time_t *)&unixTime);
		int hours;
		int minutes;
		hours = timeStruct->tm_hour;
		minutes = timeStruct->tm_min;
		
		char sFileName[30];
		sprintf(sFileName, "/Health/bloodjournal-%4d.txt", timeStruct->tm_year +1900);

        FILE* output = fopen (sFileName, "a+");
        fprintf(output, "%d/%d/%d %02d:%02d %d\n", timeStruct->tm_mon +1, timeStruct->tm_mday, timeStruct->tm_year +1900, timeStruct->tm_hour, timeStruct->tm_min, timeStruct->tm_yday);
        switch(bloodtime)
        {
            case 1:
                fprintf(output, "Pre-Breakfast\n");
                break;
            case 2:
                fprintf(output, "Pre-Lunch\n");
                break;
            case 3:
                fprintf(output, "Pre-Dinner\n");
                break;
            case 4:
                fprintf(output, "Pre-Bed\n");
                break;
        }

        fprintf(output,"%d\n", sugar);
        fclose (output);
        break;

    }
    return 0;
}

int readBloodInfo()
{
	time_t unixTime = time(NULL);
	struct tm* currentTime = gmtime((const time_t *)&unixTime);

	char sFileName[30];
	sprintf(sFileName, "/Health/bloodjournal-%4d.txt", currentTime->tm_year +1900);

	FILE* inputFile = fopen (sFileName, "r");
	
	//struct BLOODINFO bloodData[100];
	bloodDataList.clear();
	
	char sLine[50];
	int nCurrentEntry = 0;

	fgets(sLine, 50, inputFile);
	while (!feof(inputFile))
	{
		struct BLOODINFO bloodData;
		
		// mm/dd/yyyy hour:min yday
		sscanf(sLine, "%d/%d/%d %02d:%02d %d\n", &bloodData.entryTime.tm_mon, &bloodData.entryTime.tm_mday, &bloodData.entryTime.tm_year , &bloodData.entryTime.tm_hour, &bloodData.entryTime.tm_min, &bloodData.entryTime.tm_yday);
		bloodData.entryTime.tm_mon -= 1;
		bloodData.entryTime.tm_year -=1900;
		
		// meal Name
		fgets(sLine,20, inputFile);
		sscanf(sLine, "%s\n", &bloodData.sMealName);
			
		// blood sugar
		fgets(sLine,10, inputFile);
		bloodData.nBloodSugar = atoi(sLine);
		
		// add what we read to the list
		bloodDataList.push_back(bloodData);
		
		nCurrentEntry++;
		// try to read first line of next entry (mm/dd/yyyy hour:min yday)
		fgets(sLine, 50, inputFile);
	}

	nCurrentEntry--;
	
	fclose(inputFile);
	return 0;
}

float testAverageMonth(int nMonth, int nMeal)
{
	nMonth--;
	if (nMonth == -1)
	{
		time_t unixTime = time(NULL);
		struct tm* currenttime = gmtime((const time_t *)&unixTime);
		nMonth = currenttime->tm_mon;
	}
	
	int nNumFound = 0;
	float nTotalBloodSugar = 0;
	struct BLOODINFO bloodData;
	
	for (list<BLOODINFO>::iterator it=bloodDataList.begin(); it!=bloodDataList.end(); ++it)
	{
		bloodData = *it;
	
		if (bloodData.entryTime.tm_mon == nMonth)
		{ 
			// if nMeal = 0 (all meals) or if it is the mealname for that entry in the blooddata
			if ( (0 == nMeal) || (0 == strcmp(MealNames[nMeal], bloodData.sMealName))) 
			{
				nNumFound++;
				nTotalBloodSugar += bloodData.nBloodSugar;
			}
		} 
	}
	
	float nAverageMonth = 0;
	if (nNumFound > 0)
	{
		nAverageMonth = nTotalBloodSugar / nNumFound;
	}
	cout << "Average Blood Sugar for\n" << months[nMonth]<< ": "<< nAverageMonth << "\n";
	
	return nAverageMonth;
}

float testAverageYear(int nMeal)
{
	int nNumFound = 0;
	float nTotalBloodSugar = 0;
	struct BLOODINFO bloodData;
	
	for (list<BLOODINFO>::iterator it=bloodDataList.begin(); it!=bloodDataList.end(); ++it)
	{
		bloodData = *it;
	
		// if nMeal = 0 (all meals) or if it is the mealname for that entry in the blooddata
		if ( (0 == nMeal) || (0 == strcmp(MealNames[nMeal], bloodData.sMealName))) 
		{
			nNumFound++;
			nTotalBloodSugar += bloodData.nBloodSugar;
		}
	}
	
	float nAverageYear = 0;
	if (nNumFound > 0)
	{
		nAverageYear = nTotalBloodSugar / nNumFound;
	}
	cout << "Average Blood Sugar for\n" << "Current year: "<< nAverageYear << "\n";
	
	return nAverageYear;
}

float testAverageDays(int nDays, int nMeal)
{
	time_t unixTime = time(NULL);
	struct tm* currenttime = gmtime((const time_t *)&unixTime);

	int nNumFound = 0;
	float nTotalBloodSugar = 0;
	struct BLOODINFO bloodData;
	
	for (list<BLOODINFO>::iterator it=bloodDataList.begin(); it!=bloodDataList.end(); ++it)
	{
		bloodData = *it;
	
		if ( (currenttime->tm_yday - bloodData.entryTime.tm_yday) <= nDays)
		{
			// if nMeal = 0 (all meals) or if it is the mealname for that entry in the blooddata
			if ( (0 == nMeal) || (0 == strcmp(MealNames[nMeal], bloodData.sMealName))) 
			{
				nNumFound++;
				nTotalBloodSugar += bloodData.nBloodSugar;
			}
		}
	}
	
	float nAverageDays = 0;
	if (nNumFound > 0)
	{
		nAverageDays = nTotalBloodSugar / nNumFound;
	}
	cout << "Average Blood Sugar for\n" << nDays << " days: "<< nAverageDays << "\n";
	
	return nAverageDays;
}
void average()
{
    float averageAll;
    float averagePreBreakfast;
    float averagePreLunch;
    float averagePreDinner;
    float averagePreBed;
    clearWhichScreen(BOTHSCREENS);
    int optionselected;
    readBloodInfo();
    scanKeys();
    char menuItems[3][50];
	strcpy(menuItems[0], "Days");
	strcpy(menuItems[1], "Months");
	strcpy(menuItems[2], "Years");
	optionselected=menu(3, menuItems);
	if(optionselected==1)
	{
	    scanKeys();
	    clearWhichScreen(BOTHSCREENS);
	    strcpy(menuItems[0], "7 Days");
	    strcpy(menuItems[1], "14 Days");
	    optionselected=menu(2, menuItems);
	    if(optionselected==1)
	    {
	        scanKeys();
	        averageAll = testAverageDays(7,0);
	        averagePreBreakfast = testAverageDays(7,1);
	        averagePreLunch = testAverageDays(7,2);
	        averagePreDinner = testAverageDays(7,3);
	        averagePreBed = testAverageDays(7,4);
	        clearWhichScreen(BOTHSCREENS);
	        cout<<"Your average blood sugar for\nthe past 7 days was:\n\n";
	        cout<<"All: "<<averageAll<<"\n";
	        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
	        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
	        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
	        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
            scanKeys();
            while(!keysDown())scanKeys();
            clearWhichScreen(BOTHSCREENS);
	    }
	    if(optionselected==2)
	    {
	        scanKeys();
	        averageAll = testAverageDays(14,0);
	        averagePreBreakfast = testAverageDays(14,1);
	        averagePreLunch = testAverageDays(14,2);
	        averagePreDinner = testAverageDays(14,3);
	        averagePreBed = testAverageDays(14,4);
	        clearWhichScreen(BOTHSCREENS);
	        cout<<"Your average blood sugar for\nthe past 14 days was:\n\n";
	        cout<<"All: "<<averageAll<<"\n";
	        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
	        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
	        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
	        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
            scanKeys();
            while(!keysDown())scanKeys();
            clearWhichScreen(BOTHSCREENS);
	    }
	}
	if(optionselected==2)
	{
	    scanKeys();
	    clearWhichScreen(BOTHSCREENS);
	    strcpy(menuItems[0], "1 Month");
	    strcpy(menuItems[1], "3 Months");
	    strcpy(menuItems[2], "6 Months");
	    strcpy(menuItems[3], "9 Months");
	    optionselected=menu(4, menuItems);
	    if(optionselected==1)
	    {
	        scanKeys();
	        averageAll = testAverageMonth(0,0);
	        averagePreBreakfast = testAverageMonth(0,1);
	        averagePreLunch = testAverageMonth(0,2);
	        averagePreDinner = testAverageMonth(0,3);
	        averagePreBed = testAverageMonth(0,4);
	        clearWhichScreen(BOTHSCREENS);
	        cout<<"Your average blood sugar for\nthe past month was:\n\n";
	        cout<<"All: "<<averageAll<<"\n";
	        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
	        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
	        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
	        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
            scanKeys();
            while(!keysDown())scanKeys();
            clearWhichScreen(BOTHSCREENS);
	    }
	    if(optionselected==2)
	    {
            scanKeys();
	        averageAll = testAverageMonth(3,0);
	        averagePreBreakfast = testAverageMonth(3,1);
	        averagePreLunch = testAverageMonth(3,2);
	        averagePreDinner = testAverageMonth(3,3);
	        averagePreBed = testAverageMonth(3,4);
	        clearWhichScreen(BOTHSCREENS);
	        cout<<"Your average blood sugar for\nthe past 3 months was:\n\n";
	        cout<<"All: "<<averageAll<<"\n";
	        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
	        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
	        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
	        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
            scanKeys();
            while(!keysDown())scanKeys();
            clearWhichScreen(BOTHSCREENS);
	    }
	    if(optionselected==3)
	    {
            scanKeys();
	        averageAll = testAverageMonth(6,0);
	        averagePreBreakfast = testAverageMonth(6,1);
	        averagePreLunch = testAverageMonth(6,2);
	        averagePreDinner = testAverageMonth(6,3);
	        averagePreBed = testAverageMonth(6,4);
	        clearWhichScreen(BOTHSCREENS);
	        cout<<"Your average blood sugar for\nthe past 6 months was:\n\n";
	        cout<<"All: "<<averageAll<<"\n";
	        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
	        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
	        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
	        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
            scanKeys();
            while(!keysDown())scanKeys();
            clearWhichScreen(BOTHSCREENS);
	    }
	    if(optionselected==4)
	    {
            scanKeys();
	        averageAll = testAverageMonth(9,0);
	        averagePreBreakfast = testAverageMonth(9,1);
	        averagePreLunch = testAverageMonth(9,2);
	        averagePreDinner = testAverageMonth(9,3);
	        averagePreBed = testAverageMonth(9,4);
	        clearWhichScreen(BOTHSCREENS);
	        cout<<"Your average blood sugar for\nthe past 9 months was:\n\n";
	        cout<<"All: "<<averageAll<<"\n";
	        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
	        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
	        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
	        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
            scanKeys();
            while(!keysDown())scanKeys();
            clearWhichScreen(BOTHSCREENS);
	    }
	}
	if(optionselected==3)
	{
	    scanKeys();
	    clearWhichScreen(BOTHSCREENS);
        scanKeys();
        averageAll = testAverageYear(0);
        averagePreBreakfast = testAverageYear(1);
        averagePreLunch = testAverageYear(2);
        averagePreDinner = testAverageYear(3);
        averagePreBed = testAverageYear(4);
        clearWhichScreen(BOTHSCREENS);
        cout<<"Your average blood sugar for\nthe past year was:\n\n";
        cout<<"All: "<<averageAll<<"\n";
        cout<<"Pre-Breakfast: "<<averagePreBreakfast<<"\n";
        cout<<"Pre-Lunch: "<<averagePreLunch<<"\n";
        cout<<"Pre-Dinner: "<<averagePreDinner<<"\n";
        cout<<"Pre-Bed: "<<averagePreBed<<"\n";
        scanKeys();
    	while(!keysDown())scanKeys();
    	clearWhichScreen(BOTHSCREENS);
    	
    }
}
void journal()
{
    while(1)
    {
    clearWhichScreen(BOTHSCREENS);
    int optionselected = 0;
    char menuItems[4][50];
	strcpy(menuItems[0], "Unit Count");
	strcpy(menuItems[1], "Blood Sugar Averages");
	strcpy(menuItems[2], "Configure Maximum Units");
	strcpy(menuItems[3], "Back");
	optionselected=menu(4, menuItems);
	
	if(optionselected == 1)
	{
	    FILE* config = fopen ("/Health/config.ini", "r");
        int maxUnits;
        fscanf(config, "%i", &maxUnits);
        fclose (config);
        FILE* unitInput = fopen ("/Health/units.ini", "r");
        int currentUnits;
        fscanf(unitInput, "%i", &currentUnits);
        fclose (unitInput);
        
        cout<<"Your maximum units: "<<maxUnits;
        cout<<"\n\nYour current units: "<<currentUnits;
        scanKeys();
        while(!keysDown())scanKeys();
        swiWaitForVBlank();
	}
	if(optionselected == 2)
	{
	    average();
	}
	if(optionselected == 3)
	{
	    FILE* config = fopen ("/Health/config.ini", "r");
        int maxUnits;
        fscanf(config, "%i", &maxUnits);
        fclose (config);
	    cout<<"Your current maximum units\nare: "<<maxUnits;
	    cout<<"\n\nAre you sure you want to change\nyour maximum units?";
	    scanKeys();
	    while(!keysDown())scanKeys();
        swiWaitForVBlank();
        clearWhichScreen(BOTHSCREENS);
	    int optionselected = 0;
        char menuItems[2][50];
    	strcpy(menuItems[0], "Yes");
    	strcpy(menuItems[1], "No");
    	optionselected=menu(2, menuItems);
    	
    	int newMax;
    	
    	if(optionselected==1)
    	{
    	    keyboardShow();
    	    cout<<"What's the new maximum?\n\n";
            while(1)
            {
                consoleSelect(&bottomScreen);
                if (1 == scanf("%i", &newMax))
                {
                    clearWhichScreen(BOTHSCREENS);
                    keyboardHide();
                    break;
                }
                else
                {
                    swiWaitForVBlank();
                    clearWhichScreen(BOTHSCREENS);			
                    cout<<"Error: Please enter a number.\n\n";
                    consoleSelect(&topScreen);
                    cout<<"What's the new maximum?\n\n";
                    char c; // used to clear the input
                    while((c = getchar()) != '\n' && c != EOF); // This clears the input variable.

                }
            }
    	    FILE* config = fopen ("/Health/config.ini", "w+");
            fprintf(config, "%i", newMax);
            fclose (config);
            scanKeys();
    	    while(!keysDown())scanKeys();
            swiWaitForVBlank();
        }
	}
	if(optionselected == 4)
	{
    	clearWhichScreen(BOTHSCREENS);
    	break;
	}
	}
}
